<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table class="table table-bordered table-striped table-hover" id="table-users">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody id="tbody">
        
      </tbody>
    </table>
  </div>
  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  });
  
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading(){
    var vUserObj=JSON.parse(gJsonUser);
    loadDataToUserTable(vUserObj.users);
    $(".user-detail").on("click", function(){
    onBtnDetailClick(this);
  });
  }
  function onBtnDetailClick(paramButton){
    console.log("Nút Chi Tiết được bấm");
    console.log($(paramButton).data("firstname"));
  }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToUserTable(paramUsers){
    var vUserTable=$("#table-users");
    //thêm row mới
    for (var bI=0; bI<paramUsers.length; bI++){
    var bNewRow=$("<tr>").appendTo(vUserTable);
    //thêm các ô, điền dữ liệu vào các ô
    var bUserCode=$("<td>", {html:paramUsers[bI].userId}).appendTo(bNewRow);
    var bUserFirstName=$("<td>",{html:paramUsers[bI].firstname}).appendTo(bNewRow);
    var bUserLastName=$("<td>",{html:paramUsers[bI].lastname}).appendTo(bNewRow);
    var bUserAge=$("<td>",{html:paramUsers[bI].age}).appendTo(bNewRow);
    var bUserDetail=$("<td>").appendTo(bNewRow);
    $("<button>Chi Tiết</button>")
                      .addClass('btn btn-info user-detail')
                      .data("userId",paramUsers[bI].userId)
                      .data("firstname",paramUsers[bI].firstname)
                      .data("lastname",paramUsers[bI].lastname)
                      .data("age", paramUsers[bI].age)
                      .appendTo(bUserDetail);              
    } 
  }
  </script>
</body>

</html>
​